unit RDExtRgn;
{ *************************************************
  *            FormRgn library 21.06.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *      Auxiliary unti for property editor       *
  ************************************************* }

 interface

  uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,Buttons,ExtCtrls,RgnEdit;

   type TExtRgnEditDlg=class(TForm)
                        EditX:TEdit;
                        EditY:TEdit;
                        CBoxR:TComboBox;
                        RGroupH:TRadioGroup;
                        RGroupV:TRadioGroup;
                        Label1:TLabel;
                        BtnOK:TBitBtn;
                        Label2:TLabel;
                        Label3:TLabel;
                        BitBtn2:TBitBtn;
                        procedure BtnOKClick(Sender:TObject);
                       public
                        function Execute(SP:string;RgnList:TStringList):string;
                      end;

     var ExtRgnEditDlg:TExtRgnEditDlg;

 implementation

 {$R *.DFM}

  function TExtRgnEditDlg.Execute;
   var P:Integer;
    begin
     if SP<>'' then
      begin
       case SP[1] of
        'C':RGroupH.ItemIndex:=2;
        'R':RGroupH.ItemIndex:=1
       end;
       case SP[2] of
        'B':RGroupV.ItemIndex:=1;
        'C':RGroupV.ItemIndex:=2
       end;
       P:=Pos(',',SP);
       EditX.Text:=Copy(SP,3,P-3);
       Delete(SP,1,P);
       P:=Pos(',',SP);
       EditY.Text:=Copy(SP,1,P-1);
       Delete(SP,1,P);
       CBoxR.Text:=SP
      end;
     CBoxR.Items.Assign(RgnList);
     if ShowModal=mrOK then
      begin
       case RGroupH.ItemIndex of
        0:Result:='TL';
        1:Result:='TR';
        2:Result:='TC'
       end;
       case RGroupV.ItemIndex of
        0:Result:=Result+'T';
        1:Result:=Result+'B';
        2:Result:=Result+'C'
       end;
       Result:=Result+UpperCase(EditX.Text)+','+UpperCase(EditY.Text)+','+CBoxR.Text
      end
     else
      Result:=''
    end;

  procedure TExtRgnEditDlg.BtnOKClick(Sender:TObject);
   var GoodName:Boolean;
       I:Integer;
    begin
     GoodName:=False;
     for I:=0 to CBoxR.Items.Count-1 do
      if CompareText(CBoxR.Items[I],CBoxR.Text)=0 then
       begin
        GoodName:=True;
        Break
       end;
     if not GoodName then
      GoodName:=Application.MessageBox(PChar('External region '+CBoxR.Text+' does not exist. Continue?'),'',MB_YesNo)=IDYes;
     if not GoodName then
      Exit;
     with Owner as TRgnEditDlg do
      if Check(EditX.Text) and Check(EditY.Text) then
       Self.ModalResult:=mrOK
      else
       ShowMessage('Syntax error in parameters')
    end;

 end.
